package aql

import (
	"errors"

	"git.science.uu.nl/datastrophe/query-conversion/entity"
)

// A MockService implements the query convert usecase interface (mock)
type MockService struct {
	throwError bool
}

// NewMockService creates a new query convert service (mock)
func NewMockService() *MockService {
	return &MockService{
		throwError: false,
	}
}

// ConvertQuery returns a hard coded string message (mock)
func (s *MockService) ConvertQuery(JSONQuery *entity.IncomingQueryJSON) (*string, error) {
	mockQuery := "Query converted"

	if !s.throwError {
		return &mockQuery, nil
	}
	return nil, errors.New("Failed to convert query")
}

// ToggleError decides whether the convert function throws an error
func (s *MockService) ToggleError() {
	s.throwError = !s.throwError
}
